<template>
  <div class="contract-tarification-container">
    <div class="header-block">
<!--      <div-->
<!--        class="main-title"-->
<!--      >-->
<!--        <span>Тарифы на услуги</span>-->
<!--        <ObValidateState-->
<!--          v-if="isDraft"-->
<!--          :is-valid="isExistServices"-->
<!--        />-->
<!--      </div>-->
      <ObTabs
        v-model="selectedTab"
        :items="tabsItems"
        :no-border="true"
        data-qa="tarificationTabs"
      />
    </div>
    <ObTable
      ref="serviceTable"
      :columns="columns"
      :functionalPanel="true"
      :page-limit="15"
      :remote-opt="{
        method: api.contract.getContractServices,
        arguments: {
          uuid: $route.params.id,
          caste: selectedTab.uuid
        }
      }"
      :remote-trigger="selectedTab"
      :show-add-button="isDraft && selectedTab.uuid === 'ADDITIONAL'"
      data-qa="tarificationTable"
      @add="onAddService"
    >
      <div slot="resourceType" slot-scope="{ data }">
        <div class="resource-type">
          <div class="resource-type__icon">
            <i
              class="icon isothermal-van-b-g"
            />
          </div>
          <div class="resource-type__desc">
            {{ data.item.resourceSpeciesTitle }}<br>
            {{ data.item.resourceSubtypeTitle }}. {{ data.item.resourcePatternParameter }}
          </div>
        </div>
      </div>
      <div slot="dropdownMenu" slot-scope="{ data }">
        <ObMenuDropdown
          :items="getDropdownItems(data)"
        />
      </div>
      <template slot="noneContent">
        <div class="title">Здесь вы сможете настраивать тарифы для ваших<br>{{ selectedTab.uuid === 'TRACKING' ? 'базовых' : 'дополнительных' }} услуг. Для этого добавьте хотя бы<br>одну {{ selectedTab.uuid === 'base' ? 'базовую' : 'дополнительную' }} услугу.</div>
        <ObButton
          v-if="isDraft && (!isTracking || selectedTab.uuid === 'ADDITIONAL')"
          label="Добавить услугу"
          type="flat"
          data-qa="addService"
          @click="onAddService"
        />
      </template>
    </ObTable>
    <ObModal
      ref="serviceModal"
      :title-second="titleSecondModal"
      :title="titleModalByType"
      size="large"
      data-qa="tarificationService"
    >
      <ServiceForm
        :data-source="editedService"
        @submit="onSaveService"
      />
    </ObModal>
  </div>
</template>

<script>
import api from '@/api'
import ObTable from 'common-components/src/obComponents/obTable'
import ObTabs from 'common-components/src/obComponents/obTabs'
import ObModal from 'common-components/src/obComponents/obModal'
import ObButton from 'common-components/src/obComponents/obButton'
import ServiceForm from '@/components/Contract/detail/services/ServiceTrackingForm'
import ContractDetailMixin from '@/components/Contract/detail/contract-detail-mixin'
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'
import { formatNumber } from 'common-components/src/helpers/common'

export default {
  name: 'ContractDetailTarificationTracking',
  mixins: [
    ContractDetailMixin
  ],
  components: {
    ObTable,
    ObTabs,
    ObModal,
    ServiceForm,
    ObMenuDropdown,
    ObButton
  },
  data () {
    return {
      api,
      editedService: null,
      selectedTab: {
        uuid: 'TRACKING',
        title: 'Базовые услуги'
      },
      tabsItems: [
        {
          uuid: 'TRACKING',
          title: 'Базовые услуги'
        },
        {
          uuid: 'ADDITIONAL',
          title: 'Дополнительные'
        }
      ]
    }
  },
  computed: {
    columns () {
      return [
        {
          title: 'Тип услуги',
          key: 'serviceTypeTitle',
          width: 300
        },
        {
          title: 'ЕД. изм.',
          key: 'serviceUnitTitle',
          width: 80
        },
        {
          title: 'тариф GSM (Без НДС)',
          key: 'gsmTariff',
          width: 120,
          html: ({ gsmTariff }) => formatNumber(gsmTariff / 100, { dot: 2 }) + ' ₽'
        },
        {
          title: 'тариф бортового устройства (без НДС)',
          key: 'onboardDeviceTariff',
          html: ({ onboardDeviceTariff }) => formatNumber(onboardDeviceTariff / 100, { dot: 2 }) + ' ₽'
        },
        {
          title: 'тариф моб. приложения (без НДС)',
          key: 'mobileAppTariff',
          html: ({ mobileAppTariff }) => formatNumber(mobileAppTariff / 100, { dot: 2 }) + ' ₽'
        },
        // {
        //   title: 'ДОП.ПЛАТА ЗА ОТПРАВКУ SMS (без НДС)',
        //   key: 'smsTariff',
        //   html: ({ smsTariff }) => formatNumber(smsTariff / 100) + ' ₽/км'
        // },
        {
          title: 'НДС',
          key: 'vatValue',
          html: (data) => data.vatValue === null ? `<span class="-gray-window">Не облагается</span>` : data.vatValue + '%',
          width: 80
        },
        {
          title: ' ',
          slotName: 'dropdownMenu',
          width: 90,
          action: true
        }
      ]
    },
    titleModalByType () {
      let titleMap = {
        TRACKING: 'Базовая',
        ADDITIONAL: 'Дополнительная',
      }
      return titleMap[this.selectedTab.uuid] + ' услуга'
    },
    titleSecondModal () {
      if (!this.isDraft) {
        return 'Просмотр'
      }
      return this.editedService ? 'редактирование' : 'добавление'
    }
  },
  methods: {
    onAddService () {
      this.editedService = {
        isNds: true
      }
      this.$refs.serviceModal.open()
    },
    async editService ({ uuid }) {
      try {
        let data = await api.contract.getServiceDetail({ uuid })
        this.editedService = {
          ...data,
          isNds: true,
          uuid
        }
        this.$refs.serviceModal.open()
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Не удалось загрузить данные услуги`
        })
      }
    },
    async deleteService ({ uuid, serviceCaste }) {
      try {
        await api.contract.deleteService({ uuid, serviceCaste })
        this.$notification({
          type: 'system_notification_success',
          message: `Услуга удалена`
        })
        setTimeout(() => {
          this.$refs.serviceTable.loadData()
        }, 2000)
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка удаления услуги`
        })
      }
    },
    async onSaveService ({ formData }) {
      let data = { ...formData }
      let isUpdate = Boolean(this.editedService && this.editedService.uuid)
      // let serviceUuid

      data.serviceCaste = this.selectedTab.uuid === 'TRACKING' ? 'TRACKING' : 'ADDITIONAL'
      delete data.isNds

      try {
        if (isUpdate) {
          await this.updateService(data)
        } else {
          await this.createService(data)
        }
        this.$notification({
          type: 'system_notification_success',
          message: `Услуга ${this.editedService ? 'обновлена' : 'добавлена'}`
        })
        this.$refs.serviceModal.close()
        setTimeout(() => {
          this.$refs.serviceTable.loadData({ init: true })
          // if (!isUpdate) {
          //   this.$refs.serviceTable.$once('on-load-list', (data) => {
          //     let service = data.find((item) => item.uuid === serviceUuid)
          //     service && this.onSelectService(service)
          //   })
          // }
        }, 2000)
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка ${this.editedService ? 'обновления' : 'добавления'} услуги`
        })
      }
    },
    async createService (data) {
      try {
        data.contractUuid = this.contract.uuid
        return await api.contract.createServiceTracking({ data })
      } catch (e) {
        throw e
      }
    },
    async updateService (data) {
      delete data.uuid
      delete data.serviceUnitUuid
      delete data.vatValue

      await api.contract.updateService({ data, uuid: this.editedService.uuid })
      setTimeout(() => {
        this.$refs.serviceTable.loadData()
      }, 1000)
    },
    getDropdownItems (data) {
      if (!this.isDraft) {
        return [
          {
            title: 'Просмотр услуги',
            method: () => this.editService(data.item)
          }
        ]
      }
      return [
        {
          title: 'Настроить услугу',
          method: () => this.editService(data.item)
        },
        {
          title: 'Удалить услугу',
          className: 'menu-button-danger',
          isHidden: this.selectedTab.uuid === 'TRACKING',
          method: () => this.deleteService(data.item)
        }
      ]
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.contract-tarification-container {
  display: flex;
  flex-direction: column;
  height: 100%;
  .header-block {
    position: relative;
    padding: 20px 20px 0 20px;
    &:before {
      content: '';
      display: block;
      width: 100%;
      height: 15px;
      position: absolute;
      z-index: 100;
      bottom: -15px;
      left: 0;
      pointer-events: none;
      background: linear-gradient(to bottom, rgba($color-blue-navy-blue, 0.08) 0%, rgba($color-blue-navy-blue, 0) 100%);
    }
    .main-title {
      margin-bottom: 30px;
    }
  }

  &::v-deep {
    .ob-tabs__sliding-line {
      bottom: 0;
    }
  }

  .main-title, .sub-title {
    display: flex;
    justify-content: flex-start;
    align-items: center;
    margin-bottom: 10px;

    .ob-validate-state-container {
      margin-left: 5px;
    }
  }

  .main-title {
    @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);
  }

  .sub-title {
    margin-bottom: 10px;
    @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
  }

  .resource-type {
    display: flex;
    align-items: center;
    &__icon {
      display: flex;
      align-items: center;
      justify-content: flex-end;
      width: 70px;
      margin-right: 22px;
      .icon {
        font-size: 24px;
        color: $color-grey-span;
      }
    }
    &__desc {
      font-family: Roboto, sans-serif;
      font-style: normal;
      font-weight: normal;
      font-size: 12px;
      line-height: 17px;
    }
  }
}
</style>

<style lang="scss">
  @import '~common-components/src/static/css/variables';
  .contract-tarification-container {
    table {
      min-width: auto!important;
    }
    .menu-button-danger {
      button {
        color: $color-error;
      }
    }

    .ob-table-inner {
      flex-grow: 2;
      td:first-child {
        .td-container {
          color: $color-blue-navy-blue;
        }
      }
      .ob-menu-dropdown-container:not(.--opened) {
        opacity: 0;
        pointer-events: none;
      }
      td {
        &:last-child {
          .td-container {
            justify-content: flex-end;
          }
        }
      }
      tr:hover {
        .ob-menu-dropdown-container {
          opacity: 1;
          pointer-events: all;
        }
        .resource-type {
          &__icon {
            .icon {
              color: $color-blue-navy-blue;
            }
          }
        }
      }
    }

    .ob-table-inner.tb_showMore:before {
      z-index: 10 !important;
    }

    .ob-func-panel {
      &__control-row {
        background-color: transparent;
      }
    }
  }
</style>
